<?php
	//Get system name
	if(file_exists("backend/name.txt") && file_get_contents("backend/name.txt") != "")
	{
		$sysname=file_get_contents("backend/name.txt") . " ";
	}
	else
	{
		$sysname="";
	}
?>
<?php
	//Open session
	if(file_exists("backend/altsesstore.txt") && file_get_contents("backend/altsesstore.txt") == "yes" && file_exists("backend/altsesstorepath.txt") && file_exists(file_get_contents("backend/altsesstorepath.txt")) && is_readable(file_get_contents("backend/altsesstorepath.txt")) && is_writable(file_get_contents("backend/altsesstorepath.txt")))
	{
		session_save_path(file_get_contents("backend/altsesstorepath.txt"));
	}
	session_start();
?>
<?php
	//Administrative check function (on a separate page)
	if(file_exists("backend/securitycheck.php"))
	{
		include ("backend/securitycheck.php");
	}
	else
	{
		die("Failed to open file \"backend/securitycheck.php\" in read mode. It should now be microwaved.");
	}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
  <head>
    <meta http-equiv="content-type" content="text/html; charset=utf-8">
    <meta name="generator" content="CoffeeCup HTML Editor (www.coffeecup.com)">
    <meta name="created" content="Wed, 17 Jun 2015 12:33:52 GMT">
    <meta name="description" content="Listening to a live stream? Got a song you have to hear? This is the place to request it!">
	<link rel="shortcut icon" href="backend/favicon.ico">
    <title><?php echo $sysname; ?>Music Request System-Import Song List</title>
    
    <style type="text/css">
    <!--
    body {
      color:#000000;
	  background-color:#FFFFFF;
      background-image:url('backend/background.gif');
      background-repeat:repeat;
    }
    a  { color:#FFFFFF; background-color:#0000FF; }
    a:visited { color:#FFFFFF; background-color:#800080; }
    a:hover { color:#000000; background-color:#00FF00; }
    a:active { color:#000000; background-color:#FF0000; }
    -->
    </style>
<?php
	if(file_exists("backend/logging.txt") && file_get_contents("backend/logging.txt") == "yes")
	{
		//Logging enabled
		//Change the timezone
		if(file_exists("backend/timezone.txt"))
		{
			date_default_timezone_set(file_get_contents("backend/timezone.txt"));
		}
		else
		{
			date_default_timezone_set("America/Toronto");
		}
		//Logging enabled
		$ip=$_SERVER['REMOTE_ADDR'];
		$fh=fopen("log/" . date("Ymd") . ".txt",'a') or die("Failed to open file \"log/" . date("Ymd") . ".txt\" in append mode. It should now be microwaved.");
		if(isset($_POST['s']))
		{
			//Submission started
			//Copy post value into variable (and sanitize it)
			$s=preg_replace("/[^0-9]/","",$_POST['s']);
			if($s == 1)
			{
				//Submitted file
				$date=date("g:i:s");
				fwrite($fh,$ip . " at " . $date . ": Submitted file \"" . $_FILES['ufile']['tmp_name'] . "\", size \"" . $_FILES['ufile']['size'] . "\" of type \"" . $_FILES['ufile']['type'] . "\"\r\n");
				if(securitycheck() === false)
				{
					//User is not administrator
					fclose($fh);
					die("You are not an administrator. <a href=\"login.php\">Sign in</a> or <a href=\"index.php\">Cancel</a>.");
				}
				//Move uploaded file to temporary storage
				$debug=move_uploaded_file($_FILES['ufile']['tmp_name'],"tempfile.txt");
				if($debug === true)
				{
					$date=date("g:i:s");
					fwrite($fh,$ip . " at " . $date . ": Moved file to temp location\r\n");
					//Create storage
					$list="";
					if(isset($_POST['format']) && $_POST['format'] != "" && isset($_POST['delimiter']) && $_POST['delimiter'] != "")
					{
						//Process format
						$format=filter_var($_POST['format'],FILTER_SANITIZE_STRING);
						$format=explode("-",strtolower($format));
						$artist=array_search("artist",$format);
						$title=array_search("title",$format);
						$album=array_search("album",$format);
						$year=array_search("year",$format);
						$date=date("g:i:s");
						fwrite($fh,$ip . " at " . $date . ": Processed input format\r\n");
						$delimiter=filter_var($_POST['delimiter'],FILTER_SANITIZE_STRING);
						$date=date("g:i:s");
						fwrite($fh,$ip . " at " . $date . ": Processed delimiter\r\n");
						//Read file, split file into lines
						$file=explode("\r\n",file_get_contents("tempfile.txt"));
						//For each line, split it based on the delimiter
						for($i=0;$i<count($file);$i++)
						{
							$file[$i]=explode($delimiter,$file[$i]);
						}
						$date=date("g:i:s");
						fwrite($fh,$ip . " at " . $date . ": Processed input file\r\n");
						//Process each line into the storage
						foreach($file as $song)
						{
							$list2=array("","","","");
							if(isset($artist) && $artist !== false && isset($song[$artist]) && isset($list2[$artist]))
							{
								$list2[0]=$song[$artist];
							}
							if(isset($title) && $title !== false && isset($song[$title]) && isset($list2[$title]))
							{
								$list2[1]=$song[$title];
							}
							if(isset($album) && $album !== false && isset($song[$album]) && isset($list2[$album]))
							{
								$list2[2]=$song[$album];
							}
							if(isset($year) && $year !== false && isset($song[$year]) && isset($list2[$year]))
							{
								$list2[3]=$song[$year];
							}
							$list[]=$list2;
						}
						$date=date("g:i:s");
						fwrite($fh,$ip . " at " . $date . ": Processed set of songs\r\n");
						//Implode each line based on system delimiter ("|")
						for($i=0;$i<count($list);$i++)
						{
							$list[$i]=implode("|",$list[$i]);
						}
						//Implode entire list
						$list=implode("\r\n",$list);
						$date=date("g:i:s");
						fwrite($fh,$ip . " at " . $date . ": Finalized set of songs\r\n");
						fclose($fh);
					}
					else
					{
						//Malformed submission, reset and try again
						$date=date("g:i:s");
						fwrite($fh,$ip . " at " . $date . ": Submission malformed\r\n");
						echo ("ERROR: Malformed submission; delimiter and/or format incomplete or missing. Try again.");
						$s=0;
						fclose($fh);
					}
				}
				else
				{
					//Failed to move file, reset form and try again
					$date=date("g:i:s");
					fwrite($fh,$ip . " at " . $date . ": Submission malformed\r\n");
					echo ("ERROR: Could not process the uploaded file. Please microwave it and try again.");
					$s=0;
					fclose($fh);
				}
			}
			elseif($s == 2)
			{
				//Submit the final list
				if(isset($_POST['list']) && $_POST['list'] != "")
				{	
					//Write contents of submission to song list
					$fh2=fopen("backend/songlist.txt",'a');
					if($fh2)
					{
						//Remove URL-breaking characters from list
						$list=strip_tags($_POST['list']);
						$list=str_replace("\"","'",$list);
						$list=str_replace("&"," and ",$list);
						$list=str_replace("+"," and ",$list);
						//File opened successfully
						fwrite($fh2,stripcslashes($list));
						fclose($fh2);
						$date=date("g:i:s");
						fwrite($fh,$ip . " at " . $date . ": Changed song list\r\n");
						fclose($fh);
						$status=0;
					}
					else
					{
						//Failed to open file
						$date=date("g:i:s");
						fwrite($fh,$ip . " at " . $date . ": Failed to change song list\r\n");
						fclose($fh);
						$status=1;
					}
				}
				else
				{
					//No list given
					$date=date("g:i:s");
					fwrite($fh,$ip . " at " . $date . ": No list changed\r\n");
					fclose($fh);
					$status=2;
				}
				//Remove leftover file
				unlink("tempfile.txt");
				//Get out of here
				echo("<script type=\"text/javascript\">window.location = \"listedit.php?ilstatus=$status\"</script>");
			}
			else
			{
				//Assume malformed submission
				$s=0;
				fclose($fh);
			}
		}
		else
		{
			//Not submitting
			$date=date("g:i:s");
			fwrite($fh,$ip . " at " . $date . ": Visited list importing page\r\n");
			if(securitycheck() === false)
			{
				//User is not administrator
				fclose($fh);
				die("You are not an administrator. <a href=\"login.php\">Sign in</a> or <a href=\"index.php\">Cancel</a>.");
			}
			fclose($fh);
		}
	}
	else
	{
		//Logging disabled
		if(isset($_POST['s']))
		{
			//Submission started
			//Copy post value into variable (and sanitize it)
			$s=preg_replace("/[^0-9]/","",$_POST['s']);
			if($s == 1)
			{
				//Submitted file
				if(securitycheck() === false)
				{
					//User is not administrator
					die("You are not an administrator. <a href=\"login.php\">Sign in</a> or <a href=\"index.php\">Cancel</a>.");
				}
				//Move uploaded file to temporary storage
				$debug=move_uploaded_file($_FILES['ufile']['tmp_name'],"tempfile.txt");
				if($debug === true)
				{
					//Create storage
					$list="";
					if(isset($_POST['format']) && $_POST['format'] != "" && isset($_POST['delimiter']) && $_POST['delimiter'] != "")
					{
						//Process format
						$format=filter_var($_POST['format'],FILTER_SANITIZE_STRING);
						$format=explode("-",strtolower($format));
						$artist=array_search("artist",$format);
						$title=array_search("title",$format);
						$album=array_search("album",$format);
						$year=array_search("year",$format);
						$delimiter=filter_var($_POST['delimiter'],FILTER_SANITIZE_STRING);
						//Read file, split file into lines
						$file=explode("\r\n",file_get_contents("tempfile.txt"));
						//For each line, split it based on the delimiter
						for($i=0;$i<count($file);$i++)
						{
							$file[$i]=explode($delimiter,$file[$i]);
						}
						//Process each line into the storage
						foreach($file as $song)
						{
							$list2=array("","","","");
							if(isset($artist) && $artist !== false && isset($song[$artist]) && isset($list2[$artist]))
							{
								$list2[0]=$song[$artist];
							}
							if(isset($title) && $title !== false && isset($song[$title]) && isset($list2[$title]))
							{
								$list2[1]=$song[$title];
							}
							if(isset($album) && $album !== false && isset($song[$album]) && isset($list2[$album]))
							{
								$list2[2]=$song[$album];
							}
							if(isset($year) && $year !== false && isset($song[$year]) && isset($list2[$year]))
							{
								$list2[3]=$song[$year];
							}
							$list[]=$list2;
						}
						//Implode each line based on system delimiter ("|")
						for($i=0;$i<count($list);$i++)
						{
							$list[$i]=implode("|",$list[$i]);
						}
						//Implode entire list
						$list=implode("\r\n",$list);
					}
					else
					{
						//Malformed submission, reset and try again
						echo ("ERROR: Malformed submission; delimiter and/or format incomplete or missing. Try again.");
						$s=0;
					}
				}
				else
				{
					//Failed to move file, reset form and try again
					echo ("ERROR: Could not process the uploaded file. Please microwave it and try again.");
					$s=0;
				}
			}
			elseif($s == 2)
			{
				//Submit the final list
				if(isset($_POST['list']) && $_POST['list'] != "")
				{	
					//Write contents of submission to song list
					$fh2=fopen("backend/songlist.txt",'a');
					if($fh2)
					{
						//Remove URL-breaking characters from list
						$list=strip_tags($_POST['list']);
						$list=str_replace("\"","'",$list);
						$list=str_replace("&"," and ",$list);
						$list=str_replace("+"," and ",$list);
						//File opened successfully
						fwrite($fh2,"\r\n" . stripcslashes($list));
						fclose($fh2);
						$status=0;
					}
					else
					{
						//Failed to open file
						$status=1;
					}
				}
				else
				{
					//No list given
					$status=2;
				}
				//Remove leftover file
				unlink("tempfile.txt");
				//Get out of here
				echo("<script type=\"text/javascript\">window.location = \"listedit.php?ilstatus=$status\"</script>");
			}
			else
			{
				//Assume malformed submission
				$s=0;
			}
		}
		else
		{
			//Not submitting
			if(securitycheck() === false)
			{
				//User is not administrator
				die("You are not an administrator. <a href=\"login.php\">Sign in</a> or <a href=\"index.php\">Cancel</a>.");
			}
		}
	}
?>
  </head>
  <body>
  <h1 style="text-align:center; text-decoration:underline;"><?php echo $sysname; ?>MRS-Import Song List</h1>
  <p>This will allow you to take an input file of arbitrary format (see caveats below) and convert it into a format the MRS understands. Easy!</p>
  <p><b>HOWEVER</b>, there are some guidelines that must be followed:</p>
  <ul>
  <li>The submitted file MUST be a text file (or similar format, such as CSV). <b>Databases are unsupported!</b></li>
  <li>The format MUST contain the words "artist", "title", "album", and "year", <b>even if all are not present in the input file</b>. The system has fallbacks, but undefined behaviour may result.</li>
  <li>Keep your delimiters simple!</li>
  <li>You may only input one format and one delimiter. Every line must follow that format and the items must be separated by that delimiter.</li>
  </ul>
  <p>After submitting the file, the system will process it, and the finalized list will be displayed in the text box. Make sure it is exactly as you want it before submitting!</p>
  <p><b><u>WARNING:</u></b> The format of this list is "Artist|Title|Album|Year". Likewise, there are characters (such as &amp; and +) that are not compatible with the request handling mechanisms and should not be used. Not following either of these conventions <b>WILL</b> break the system (although it should filter out at least some of the latter)!</p>
  <form method="post" action="listedit2.php" enctype="multipart/form-data">
  <input type="hidden" name="s" value="<?php if(isset($s) && $s == 1) { echo "2"; } else { echo "1"; } ?>">
  Delimiting symbol: <input type="text" name="delimiter" <?php if(!isset($s) || (isset($s) && $s != 1)) { echo "required=\"required\""; } else { echo "disabled=\"disabled\""; } ?>><br>
  Line format (items separated by dash ('-') ONLY): <input type="text" name="format" <?php if(!isset($s) || (isset($s) && $s != 1)) { echo "required=\"required\""; } else { echo "disabled=\"disabled\""; }  ?>><br>
  File to import: <input type="file" name="ufile" <?php if(!isset($s) || (isset($s) && $s != 1)) { echo "required=\"required\""; } else { echo "disabled=\"disabled\""; }  ?>><br>
  Finalized list:<br>
  <textarea name="list" rows="30" cols="100" <?php if(isset($s) && $s == 1) { echo "required=\"required\""; } else { echo "disabled=\"disabled\""; }  ?>><?php if(isset($list)) { echo stripcslashes($list); } ?></textarea><br>
  <input type="submit"><input type="button" value="Cancel" onclick="window.location.href='listedit.php'">
  </form>
  </body>
</html>